/*
 * Copyright (c) 2007 CodeDroids ApS (http://www.codedroids.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * For further information about CodeDroids ApS, please see the
 * company website: http://www.codedroids.com
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $LastChangedRevision$
 * $LastChangedDate$
 * 
 */

package com.codedroids.oc.forms;

import javax.servlet.jsp.PageContext;

import net.sf.json.JSONObject;

import org.opencms.jsp.CmsJspActionElement;

import com.codedroids.forms.Form;

public class PersistViaJsp implements I_PersistFormToRecord {

	public static final String formAttributeName = "com.codedroids.oc.forms.PersistViaJsp.form";
	public static final String configAttributeName = "com.codedroids.oc.forms.PersistViaJsp.config";
	
	public static final String PCK_JSP = "jsp";
	
	public void init(JSONObject config, CmsJspActionElement cmsjsp, PageContext pageContext) 
	throws PersistFormToRecordException 
	{
		return;
	}

	public void finish(JSONObject config, CmsJspActionElement cmsjsp, PageContext pageContext)  
	throws PersistFormToRecordException 
	{
		return;
	}
	
	public void persist(Form form, JSONObject config, CmsJspActionElement cmsjsp, PageContext pageContext)
	throws PersistFormToRecordException 
	{		
		try {
			pageContext.setAttribute(configAttributeName, config, PageContext.REQUEST_SCOPE);
			pageContext.setAttribute(formAttributeName, form, PageContext.REQUEST_SCOPE);
			String jspfile = config.getString(PersistViaJsp.PCK_JSP);
			cmsjsp.include(jspfile);
		} catch (Exception e) {
			throw new PersistFormToRecordException(e);
		} finally {
			pageContext.removeAttribute(formAttributeName, PageContext.REQUEST_SCOPE);
			pageContext.removeAttribute(configAttributeName, PageContext.REQUEST_SCOPE);
		}

	}

}
